<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="row">
        <div class="col-lg-6 col-xl-3 card-numbers-col" v-for="(column, index) in columns" :key="index">
            <div :class="['card-numbers', { 'full-card': item.id === 1 || item.id === 4 }]" v-for="(item, ind) in column" :key="item.id" @click="goToLink(item)">
                <div class="card-numbers-top">
                    <h3 class="card-numbers-title"><i :class="'icon-'+item.icon"></i>{{ item.title }}</h3>
                </div>
                <div class="card-numbers-list" v-if="item.more_data.length > 0">
                    <div class="card-numbers-list-title">Recent Updates </div>
                    <div class="card-numbers-item" v-for="data in item.more_data" :key="data.id">
                        <div class="card-numbers-item-name">{{ data.name }}<span></span></div>
                        <div class="card-numbers-item-value"><span :class="['classification', getClassificationClass(data.value)]"></span>{{ data.value }}</div>
                    </div>
                </div>
                <div class="card-numbers-bottom">
                    <div class="card-numbers-total">{{ item.number }}</div>
                    <div class="button-arrow"><i class="icon icon-arrow-right"></i></div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue';
import { routerKey } from 'vue-router';

const { numbers } = defineProps<{ numbers: Array<any> }>();

// Define a computed property to organize the numbers into columns
const columns = computed(() => {
    return [
        [numbers[0]],
        [numbers[1], numbers[2]],
        [numbers[3]],
        [numbers[4], numbers[5]]
    ];
});

const getClassificationClass = (value: number) => {
    if (value > 80) {
        return 'high';
    } else if (value > 60) {
        return 'medium';
    } else {
        return 'low';
    }
};

const goToLink = (item: any) => {
    if( item.link ) {
        navigateTo(item.link);
    }
}
</script>